
// BusyProg.java
// Andrew Davison, ad@fivedots.coe.psu.ac.th, March 2009

/* A never-ending program to test out the Whorld visualization.
   Each of the three functions takes a few seconds to run, so each
   visual appears for a good amount of time.

   The three functions are different byte sizes, and so should
   use different numbers of Whorld parameters when they are
   visualized.

   Usage:
     > javac BusyProg.java
     > runTrace BuyProg
*/

import java.util.*;

public class BusyProg
{

  public static void main(String[] args)
  {
    Random rand = new Random();
    int i;
    while(true) {   // keep randomly calling one of the methods
      i = rand.nextInt(3);
      if (i == 0)
        foo();
      else if (i == 1)
        bar();
      else
        tar();
    }
  } // end of main()
 
 
  private static void foo()
  { System.out.println("Running foo...");
    try {
      Thread.sleep(3000); // in ms
    } 
    catch (InterruptedException e) 
    { e.printStackTrace(); }
  }  // end of foo()


  private static void bar()
  { System.out.println("Running bar...");
    try {
      Thread.sleep(3000);
    } 
    catch (InterruptedException e) 
    { e.printStackTrace(); }

    int[] a = new int[20];
    for (int i=0; i < 20; i++) 
       a[i] = i;
  }  // end of bar()


  private static void tar()
  { System.out.println("Running tar...");
    try {
      Thread.sleep(3000);
    } 
    catch (InterruptedException e) 
    { e.printStackTrace(); }

    int[] a = new int[20];
    for (int i=0; i < 20; i++) 
       a[i] = i;

    int[] b = new int[20];
    for (int i=0; i < 20; i++) 
       b[i] = i;

    int[] c = new int[20];
    for (int i=0; i < 20; i++) 
       c[i] = i;
  }  // end of tar()


}  // end of BusyProg class
