
// MIDIInfo.java
// Andrew Davison, March 2009, ad@fivedots.coe.psu.ac.th

// list I/O details about all the system's MIDI devices



import javax.sound.midi.*;


public class MIDIInfo
{

  public static void main(String[] args)
  {
    try {
      MidiDevice.Info[] devices = MidiSystem.getMidiDeviceInfo();
      for(int i=0; i < devices.length; i++){
        System.out.print("MIDI device "+i+": ");
        MidiDevice dev = MidiSystem.getMidiDevice(devices[i]);

        boolean	bAllowsInput = (dev.getMaxTransmitters() != 0);
        boolean	bAllowsOutput = (dev.getMaxReceivers() != 0);
		System.out.print( (bAllowsInput?"IN ":"   ") +
						  (bAllowsOutput?"OUT ":"    "));

        if(MidiSystem.getMidiDevice(devices[i]) instanceof Receiver)
          System.out.print("receiver\t");
        if(MidiSystem.getMidiDevice(devices[i]) instanceof Transmitter)
          System.out.print("transmitter\t");
        if(MidiSystem.getMidiDevice(devices[i]) instanceof Synthesizer)
          System.out.print("synthesizer\t");
        if(MidiSystem.getMidiDevice(devices[i]) instanceof Sequencer)
          System.out.print("sequencer");
        System.out.println();

        System.out.println("\t"+devices[i].getName()+" ("+
                               devices[i].getDescription()+")\t");
      }
    }
    catch (MidiUnavailableException e){
      System.out.println("No devices available");
      System.exit(0);
    }
  }  // end of main()


} // end of MIDIInfo class
